#!/usr/bin/env python
"""
Module name:		
	ionoconslib.py
Description:	
	collection of used constants	
Version: v1	
Author:		Mainul Hoque
Created:	20.11.2014
Copyright:	(c) Mainul Hoque 2014
Mail:		Mainul.Hoque@dlr.de
Licence:	DLR
#-------------------------------------------------------------------------------
"""
import numpy as np
import datetime
import sys

#used for Earth's geographic to geomagnetic latitude conversion
phi_GNP		= np.deg2rad(79.74)                                 #latitude of geomagnetic North Pole used
lambda_GNP	= np.deg2rad(-71.78)                                #longitude of geomagnetic North Pole use		
		
# Constants defined by the World Geodetic System 1984 (WGS84)
smaj = 6378.137                                                     #semimajor axis in km
smin = 6356.7523142                                                  #semi minor axis in km
esq = 6.69437999014 * 0.001                                       
e1sq = 6.73949674228 * 0.001 
flat = 1 / 298.257223563                                             #flattening
REm = 6371211.266 #Earth's mean radius in meter
