#!/usr/bin/env python
#-------------------------------------------------------------------------------
# Name:         CompilationAndTest.py
#
# Purpose:      generate NeQuickIonosondeLibrary from fortran source by gfortran,
#				copy the file to the Python environment and execute the python wrapper as test
#
# Created:      12.03.2014
# Copyright:    (c) David Minkwitz 2014
# Mail:         David.Minkwitz@dlr.de
# Licence:      DLR
#-------------------------------------------------------------------------------

import sys
import subprocess

import os

sys.path.insert(0,'/home/mink_da/3DReconstruction/Software/Diverses/Python/NeQuickPythonInterface/NeQuick_PythonEnvironment/')
sys.path.insert(1,'/home/mink_da/3DReconstruction/Software/Scripts/DailyBread/')

#import colored

class CompilationAndTest():
	"""
	...
	"""
	
	def __init__(self):
		"""
		...
		"""
		self.__initData()
		print('*** [' + self.__class__.__name__ + ']: initiated ...')


	def __del__(self):
		"""
		This is the destructor.
		"""
		pass
		
		
	def __initData(self):
		#self.nequickPath 		= '/home/mink_da/3DReconstruction/Software/Diverses/Python/NeQuickPythonInterface/NeQuick_PythonEnvironment/'
		self.nequickPath 		= './'
		self.fortranFilename 	= 'NeQuickIonosonde_gridProcessing.for'
		self.libraryFileName	= 'NeQuickIonosonde_gridProcessing.so'	
			
		
	def __doCompilation(self):
		#f2py -L/usr/lib/gcc/x86_64-redhat-linux/4.4.5/ -lgfortran -c -m --f77exec="gfortran -fPIC -ffixed-line-length-250" NeQuickIonosonde NeQuickIonosonde.for
		#if os.path.isfile(self.libraryFileName):
	#		print "remove:",self.libraryFileName
#			newLibraryFilename = 'backup_' + self.libraryFileName
#			shutil.move(self.libraryFileName,newLibraryFilename)
		
		print "compile:",self.fortranFilename
		#process = subprocess.Popen('f2py -L/usr/lib/gcc/x86_64-redhat-linux/4.4.5/ -lgfortran -c -m --f77exec="gfortran -fPIC -ffixed-line-length-250" NeQuickIonosonde NeQuickIonosonde.for',shell=True)
		process = subprocess.Popen('f2py2.7 -L/usr/lib/gcc/x86_64-redhat-linux/4.8.2/ -lgfortran -c -m --f77exec="gfortran -fPIC -ffixed-line-length-250" NeQuick NeQuick_2_0_2.for',shell=True)
		process.wait()
		
		newFilename = self.nequickPath + self.libraryFileName
		#shutil.move(self.libraryFileName,newFilename)
		string = "move: " + self.libraryFileName + ' to: ' + newFilename
		#colored.printError(string)
		
		
	def test(self):
		self.__doCompilation()
		os.chdir(self.nequickPath)
        from bin.reconstruct import NeQuick as nequickWrapper

        nequickObj = nequickWrapper.NeQuickIonosondeWrapper()
		nequickObj.demo()
		pass
		

def main():
	
	compTest = CompilationAndTest()
	compTest.test()
	
if __name__ == "__main__":
	main()
